import Ajv from 'ajv';
import React, { CSSProperties } from 'react';
import { IComponentMap, IViewsMap } from './components/ComponentMap';
import CpuEditorContext from './context';
import { ResourceOptions } from './context/resources';
import { JSONSchema } from './type/Schema';
export interface EditorProps<T = any> {
    onChange?: (data: any) => void | null;
    data?: any;
    schema?: JSONSchema | boolean;
    id?: string | undefined;
    style?: CSSProperties;
    componentMap: IComponentMap<T>;
    viewsMap?: Record<string, IViewsMap>;
    rootMenuItems?: JSX.Element[];
    options?: {
        ajvInstance?: Ajv;
        resources?: ResourceOptions;
    };
    providerProps?: T;
}
export declare const InfoContext: React.Context<CpuEditorContext>;
declare const _default: React.MemoExoticComponent<React.ForwardRefExoticComponent<EditorProps<any> & React.RefAttributes<CpuEditorContext>>>;
export default _default;
