/// <reference types="react" />
import CpuEditorContext from '../../context';
import { FieldProps, IField } from '../../Field';
import { ComponentModel } from '../ComponentModel';
/**
 * [业务] 将 componentModel 挂载到 ctx.interaction
 * @param ctx
 * @param route
 * @param field
 * @param viewport
 * @param model
 * @returns
 */
export declare const useContainer: (ctx: CpuEditorContext, fieldProps: FieldProps, fieldInfo: IField) => {
    titleElement: JSX.Element;
    editionElement: JSX.Element;
    editionInfo: {
        readonly valueType: "string" | "number" | "bigint" | "boolean" | "symbol" | "undefined" | "object" | "function" | "enum" | "const" | "array" | "null";
        readonly viewType: string | undefined;
        readonly format: string | undefined;
    };
    model: ComponentModel;
    fieldNameRange: string | RegExp;
    id: string;
};
