import { useMemo } from 'react';
import { jsonDataType } from "../../utils";
/**
 * [业务]获取到数组/对象数据的 fatherInfo
 * @param data
 * @param schemaEntry
 * @param valueEntry
 * @param mergedValueSchema
 * @returns
 */
export var useFatherInfo = function useFatherInfo(data, schemaEntry, valueEntry, mergedValueSchema) {
  var dataType = jsonDataType(data);
  return useMemo(function () {
    var _ref = mergedValueSchema || {},
      required = _ref.required;
    var childFatherInfo = {
      schemaEntry: schemaEntry,
      valueEntry: valueEntry,
      type: dataType
    };
    switch (dataType) {
      case 'array':
        childFatherInfo.type = 'array';
        childFatherInfo.length = data.length;
        break;
      default:
        childFatherInfo.type = 'object';
        if (required) childFatherInfo.required = required;
        break;
    }
    return childFatherInfo;
  }, [mergedValueSchema, valueEntry, schemaEntry, dataType]);
};