import React, { useCallback } from 'react';
import { getFieldSchema } from "../../utils/schemaWithRef";
/**
 * [业务]返回一个函数，传入 key 和 shortLevel 可以取得 subField 的 Field 组件
 * @param data
 * @param access
 * @param fieldInfo
 * @param fatherInfo
 * @param viewport
 * @returns
 */
export var useFieldModel = function useFieldModel(ctx, data, access, fieldInfo, fatherInfo, viewport) {
  var mergedValueSchema = fieldInfo.mergedValueSchema,
    valueEntry = fieldInfo.valueEntry;
  return useCallback(function (key, short) {
    var subEntry = getFieldSchema(data, valueEntry, mergedValueSchema, key) || undefined;
    var Field = ctx.Field;
    return /*#__PURE__*/React.createElement(Field, {
      viewport: viewport,
      route: access,
      field: key,
      fatherInfo: fatherInfo,
      schemaEntry: subEntry,
      short: short
    });
  }, [data, access, valueEntry, fieldInfo, fatherInfo, ctx]);
};