import CpuEditorContext from '.';
import { MergedSchemaWithoutVirtual } from './mergeSchema';
export declare const isShort: unique symbol;
export declare type virtualSchemaProps = {
    [isShort]: boolean;
};
/**
 * 确定schema是否可以短优化。条件：
 * 1. 类型确定且为string/number/bool/null，且没有oneof
 * 2. 有enum
 * 注：由于目前该函数主要从 valueInfo 确定子属性时调用，所以不必缓存。
 * @param mergedSchema
 */
export declare const schemaIsShort: (ctx: CpuEditorContext, mergedSchema: MergedSchemaWithoutVirtual) => boolean;
