import CpuEditorContext from '../context';
import { MergedSchema } from '../context/mergeSchema';
export declare enum ShortLevel {
    no = 0,
    short = 1,
    extra = 2
}
/**
 * 确定一个数据的**常量名称**。
 * 定义具体详见 [常量名称](https://gitee.com/furtherbank/json-schemaeditor-antd#常量名称)
 * @param v
 * @returns
 */
export declare const toConstName: (v: any) => any;
/**
 * 确定一个模式在 of 选项中展示的**模式名称**。
 * 定义具体详见 [模式名称](https://gitee.com/furtherbank/json-schemaeditor-antd#模式名称)
 * @param mergedSchema 处理合并后的模式
 * @returns
 */
export declare const toOfName: (mergedSchema: MergedSchema) => string;
/**
 * 得到当前 schemaEntry 下的 valueEntry 和 ofOption
 * @param data 当前数据
 * @param schemaEntry 当前数据的 schemaEntry
 * @param ctx 编辑器上下文对象
 * @returns
 */
export declare const getValueEntry: (data: any, schemaEntry: string | undefined, ctx: CpuEditorContext) => {
    valueEntry: string | undefined;
    ofOption: string | false | null;
};
/**
 * 得到当前数据通过 instancePath 继续查找得到的 schemaEntry
 * @param data 当然数据
 * @param path 继续的数据路径
 * @param ctx 编辑器上下文对象
 * @param curEntry 当前的 valueEntry，从这里开始查找
 */
export declare const getSchemaEntryByPath: (data: any, path: string[], ctx: CpuEditorContext, curEntry?: string) => string | undefined;
