/// <reference types="redux-undo" />
import { ErrorObject } from 'ajv';
import CpuEditorContext from '../context';
export interface CpuEditorActionOption {
    route?: string[];
    field?: string;
    value?: any;
    /**
     * 局部验证所需要的 schemaEntry，具体是谁的 schemaEntry 由传入的组件决定
     */
    schemaEntry?: string;
}
export interface CpuEditorAction extends CpuEditorActionOption {
    type: string;
}
export interface CpuEditorState {
    data: any;
    dataErrors: Record<string, ErrorObject<string, Record<string, any>, unknown>[]>;
}
export declare const doAction: (type: string, options: CpuEditorActionOption) => CpuEditorAction;
export declare type CpuEditorActionDispatcher = typeof doAction;
export declare const JsonTypes: string[];
/**
 * 导出 editor 的 reducer 方法，其中可使用 ctx 闭包上下文
 * @param ctx
 * @returns
 */
export declare const getReducer: (ctx: CpuEditorContext) => Reducer<import("redux-undo").StateWithHistory<State>>;
