export declare const KeywordTypes: any;
export declare const getKeywordType: (keyword: string) => string;
export declare const concatAccess: (route: string[], ...args: (string | null | undefined)[]) => string[];
export declare const jsonDataType: (data: any) => "string" | "number" | "bigint" | "boolean" | "symbol" | "undefined" | "object" | "function" | "array" | "null";
/**
 * 简单的迭代器转数组
 * @param it 迭代器
 * @returns
 */
export declare const iterToArray: <T>(it: Iterable<T>) => T[];
/**
 * 给 uri 路径继续添加子路径。
 * 不提供子路径也可以当作去末尾 / 的格式化工具
 * @param ref uri 路径
 * @param path 需要添加的子路径
 * @returns
 */
export declare const addRef: (ref: string | undefined, ...path: string[]) => string | undefined;
/**
 * 通过 data access 得到 data 的 ref 字符串，用作 id
 * todo: 只要有需要对这个输出字符串分割的可能，必须要转义
 * @param access
 * @returns
 */
export declare const getFieldDomId: (viewport: string, access: string[]) => string;
/**
 * 通过 field 组件 dom 的 id 得到其信息
 * @param id
 * @returns
 */
export declare const extractFieldDomId: (id: string) => {
    viewport: string;
    path: string;
    pathArray: string[];
};
/**
 * 通过数组 path 得到对象树中对象的位置。
 * @param data
 * @param path
 * @returns
 */
export declare const deepGet: (data: any, path: string[]) => any;
/**
 * 设置对象树某一位置的值。
 * 如果途中遇到了已定义的非对象，会取消操作
 * @param obj
 * @param ref json-pointer string without #
 * @param value
 * @returns
 */
export declare const deepSet: (obj: any, ref: string, value: any) => any;
/**
 * 深度递归收集一个对象某个键的所有属性
 * @param obj
 * @param key
 * @returns
 */
export declare const deepCollect: (obj: any, key: string) => any[];
/**
 * 深度递归替换一个对象某个键的所有属性。
 * 注意如果需要深拷贝请提前做。
 * @param obj
 * @param key
 * @param map 替换函数
 * @returns
 */
export declare const deepReplace: (obj: any, key: string, map: (value: any, key: any) => any) => any;
/**
 * 将对象或map的keys当作正则表达式来匹配 key，如果匹配到返回这个正则表达式
 * @param map
 * @param key
 * @returns
 */
export declare const getKeyByPattern: (map: Map<string | RegExp, any> | {
    [x: string]: any;
}, key: string) => RegExp | undefined;
/**
 * 查找对象某键的值，但是正则匹配
 * @param obj 查找的对象，对象的键作为正则式与 key 匹配
 * @param key 待匹配的字符串
 * @returns
 */
export declare const getValueByPattern: <T>(obj: {
    [k: string]: T;
}, key: string) => T | undefined;
