function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
/* eslint-disable no-param-reassign */
import pointer from 'json-pointer';
import { uri2strArray } from "./path/uri";
export var KeywordTypes = {
  intersection: ['type'],
  merge: ['properties', 'patternProperties']
};
export var getKeywordType = function getKeywordType(keyword) {
  for (var type in KeywordTypes) {
    if (KeywordTypes[type].includes(keyword)) return type;
  }
  return 'first';
};
export var concatAccess = function concatAccess(route) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  var filtered = args.filter(function (value) {
    return typeof value === 'string' && value;
  });
  return route.concat(filtered);
};
export var jsonDataType = function jsonDataType(data) {
  return data === null ? 'null' : data instanceof Array ? 'array' : _typeof(data);
};

/**
 * 简单的迭代器转数组
 * @param it 迭代器
 * @returns
 */
export var iterToArray = function iterToArray(it) {
  var r = [];
  var _iterator = _createForOfIteratorHelper(it),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var ele = _step.value;
      r.push(ele);
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return r;
};

/**
 * 给 uri 路径继续添加子路径。
 * 不提供子路径也可以当作去末尾 / 的格式化工具
 * @param ref uri 路径
 * @param path 需要添加的子路径
 * @returns
 */
export var addRef = function addRef(ref) {
  if (ref === undefined) return undefined;
  if (ref[ref.length - 1] === '/') ref = ref.substring(0, ref.length - 1);
  for (var _len2 = arguments.length, path = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    path[_key2 - 1] = arguments[_key2];
  }
  path.forEach(function (v) {
    if (v) ref = ref + '/' + v;
  });
  return ref;
};

/**
 * 通过 data access 得到 data 的 ref 字符串，用作 id
 * todo: 只要有需要对这个输出字符串分割的可能，必须要转义
 * @param access
 * @returns
 */
export var getFieldDomId = function getFieldDomId(viewport, access) {
  return viewport + ':' + pointer.compile(access);
};

/**
 * 通过 field 组件 dom 的 id 得到其信息
 * @param id
 * @returns
 */
export var extractFieldDomId = function extractFieldDomId(id) {
  var index = id.indexOf(':'); // 查找分隔符的位置
  if (index === -1) {
    throw new Error("\u4F20\u5165\u5B57\u6BB5 id \u9519\u8BEF\uFF1A".concat(id));
  }
  var _ref = [id.substring(0, index), id.substring(index + 1)],
    viewport = _ref[0],
    path = _ref[1]; // 分割字符串并将其存储在数组中

  return {
    viewport: viewport,
    path: path,
    pathArray: pointer.parse(path)
  };
};

/**
 * 通过数组 path 得到对象树中对象的位置。
 * @param data
 * @param path
 * @returns
 */
export var deepGet = function deepGet(data, path) {
  var nowData = data;
  var _iterator2 = _createForOfIteratorHelper(path),
    _step2;
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var field = _step2.value;
      if (_typeof(nowData) !== 'object') return undefined;
      nowData = nowData[field];
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
  return nowData;
};

/**
 * 设置对象树某一位置的值。
 * 如果途中遇到了已定义的非对象，会取消操作
 * @param obj
 * @param ref json-pointer string without #
 * @param value
 * @returns
 */
export var deepSet = function deepSet(obj, ref, value) {
  var path = uri2strArray(ref);
  var oriObj = obj;
  path.every(function (v, i) {
    if (i === path.length - 1) {
      obj[v] = value;
    } else if (obj[v] === undefined || obj[v] === null) {
      obj[v] = {};
      obj = obj[v];
    } else if (_typeof(obj[v]) === 'object' && !(obj[v] instanceof Array)) {
      obj = obj[v];
    } else {
      return false;
    }
    return true;
  });
  return oriObj;
};

/**
 * 深度递归收集一个对象某个键的所有属性
 * @param obj
 * @param key
 * @returns
 */
export var deepCollect = function deepCollect(obj, key) {
  var collection = [];
  // js 原型链安全问题
  for (var _k in obj) {
    if (_k === key) {
      collection.push(obj[_k]);
    } else {
      if (obj[_k] && _typeof(obj[_k]) === 'object') {
        collection = collection.concat(deepCollect(obj[_k], key));
      }
    }
  }
  return collection;
};

/**
 * 深度递归替换一个对象某个键的所有属性。
 * 注意如果需要深拷贝请提前做。
 * @param obj
 * @param key
 * @param map 替换函数
 * @returns
 */
export var deepReplace = function deepReplace(obj, key, map) {
  // js 原型链安全问题
  for (var _k2 in obj) {
    if (_k2 === key) {
      obj[_k2] = map(obj[_k2], _k2);
      // console.log('替换',obj[k]);
    } else {
      if (obj[_k2] && _typeof(obj[_k2]) === 'object') obj[_k2] = deepReplace(obj[_k2], key, map);
    }
  }
  return obj;
};

/**
 * 将对象或map的keys当作正则表达式来匹配 key，如果匹配到返回这个正则表达式
 * @param map
 * @param key
 * @returns
 */
export var getKeyByPattern = function getKeyByPattern(map, key) {
  var keys = map instanceof Map ? map.keys() : Object.keys(map);
  var _iterator3 = _createForOfIteratorHelper(keys),
    _step3;
  try {
    for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
      var _k3 = _step3.value;
      var pattern = typeof _k3 === 'string' ? new RegExp(_k3) : _k3;
      if (pattern.test(key)) {
        return pattern;
      }
    }
  } catch (err) {
    _iterator3.e(err);
  } finally {
    _iterator3.f();
  }
  return undefined;
};

/**
 * 查找对象某键的值，但是正则匹配
 * @param obj 查找的对象，对象的键作为正则式与 key 匹配
 * @param key 待匹配的字符串
 * @returns
 */
export var getValueByPattern = function getValueByPattern(obj, key) {
  for (var _i = 0, _Object$keys = Object.keys(obj); _i < _Object$keys.length; _i++) {
    var _k4 = _Object$keys[_i];
    var pattern = new RegExp(_k4);
    if (pattern.test(key)) {
      return obj[_k4];
    }
  }
  return undefined;
};